#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 1e7;

ll P[N + 1];

void precalc() {
    for (ll i = 2; i * i <= N; i++) {
        if (P[i]) continue;
        for (ll j = i * i; j <= N; j += i) if (!P[j]) P[j] = i;
    }
    for (ll i = 2; i <= N; i++) if (!P[i]) P[i] = i;
}


vector<ll> factorize(ll n) {
    vector<ll> f;
    ll x = n;
    while (x != 1) f.push_back(P[x]), x /= P[x];
    return f;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    precalc();
    ll n;
    cin >> n;
    while (n--) {
        ll a, b;
        cin >> a >> b;
        vector<ll> f = factorize(a), g = factorize(b);
        reverse(f.begin(), f.end());
        reverse(g.begin(), g.end());
        ll i;
        for (i = 0; i < f.size() && i < g.size() && f[i] == g[i]; i++);
        ll ans = 1;
        for (ll j = 0; j < i; j++) ans *= f[j];
        cout << ans << '\n';
    }
}