#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("tune=native")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 10000;
const ll P = 103;
const ll M = 999999929;
ll F[N + 1];

ll hash_char(char c) {
    return c - 32;
}

ll hash_string(const string &s, vector<ll> &h) {
    h[0] = 0;
    for (ll i = 0; i < s.length(); i++) h[i + 1] = (h[i] * P % M + hash_char(s[i])) % M;
    return h.back();
}

ll hash_string(const string &s) {
    vector<ll> h(s.length() + 1);
    return hash_string(s, h);
}

ll hash_rep(const string &s, const vector<ll> &h, ll i, char c) {
    ll n = s.size();
    ll j = n - i - 1;
    ll hash = (M + h.back() - (hash_char(s[i]) * F[j]) % M) % M;
    hash += (hash_char(c) * F[j]) % M;
    hash %= M;
    return hash;
}

ll hash_without(const string &s, const vector<ll> &h, ll i) {
    ll n = s.size();
    ll j = n - i - 1;
    ll hash = (M + h.back() - (hash_char(s[i]) * F[j]) % M) % M;
    hash += (101ll * F[j]) % M;
    hash %= M;
    return hash;
}

ll or_zero(const unordered_map<ll, ll> &d, ll k) {
    if (d.find(k) != d.end()) return d.at(k);
    return 0;
}

ll cnt(const string &f, const string &s, const vector<ll> &h, const unordered_map<ll, ll> &d) {
    ll res = or_zero(d, h.back());
    for (ll i = 0; i < s.size(); i++) {
        for (char c : f) {
            if (c == s[i]) continue;
            ll hash = hash_rep(s, h, i, c);
            res += or_zero(d, hash);
        }
    }
    return res;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    F[0] = 1;
    for (ll i = 1; i <= N; i++) F[i] = (F[i - 1] * P) % M;
    ll n, k, m;
    cin >> n >> k >> m;
    string f;
    cin >> f;
    vector<string> s(n);
    vector<vector<ll>> h(n, vector<ll>(k + 1));
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
        hash_string(s[i], h[i]);
    }
    unordered_map<ll, ll> d;
    for (ll i = 0; i < n; i++) {
        d[h[i].back()]++;
        for (ll j = 0; j < k; j++) d[hash_without(s[i], h[i], j)]++;
    }
    for (ll i = 0; i < n; i++) {
        ll ans = 0;
        string ans_s;
        if (cnt(f, s[i], h[i], d) == 1) ans++, ans_s = s[i];
        for (ll j = 0; j < k; j++) {
            for (char c : f) {
                if (s[i][j] == c) continue;
                string s1 = s[i];
                s1[j] = c;
                vector<ll> h1(k + 1);
                hash_string(s1, h1);
                if (cnt(f, s1, h1, d) == 1) ans++, ans_s = s1;
            }
        }
        cout << ans;
        if (ans) cout << ' ' << ans_s;
        cout << '\n';
    }
}
