#include <iostream>
#include <vector>

void dfs(int u, const std::vector<std::vector<int>>& g,	int p, std::vector<int>& seq)
{
    seq.push_back(u);
    if (p != -1 && g[u].size() == 1) return;
    for (int v: g[u]) {
	if (v == p) continue;
	dfs(v, g, u, seq);
    }
}

int main()
{
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
	int u, v;
	std::cin >> u >> v;
	--u, --v;
	g[u].push_back(v);
	g[v].push_back(u);
    }
    if (n <= 20) {
	for (int i = 1; i <= n; ++i) {
	    std::cout << i << std::endl;
	    int result;
	    std::cin >> result;
	    if (result == 0) {
		std::cout << "! " << i << std::endl;
		return 0;
	    }
	}
    }
    bool group2 = true;
    int start;
    for (int i = 0; i < n; ++i) {
	if (g[i].size() > 2) {
	    group2 = false;
	    break;
	}
	if (g[i].size() == 1) start = i;
    }
    if (group2) {
	std::vector<int> seq;
	dfs(start, g, -1, seq);
	int l = 0, r = n;
	while (l < r) {
	    int md = (l + r) / 2;
	    std::cout << seq[md] + 1 << std::endl;
	    int result;
	    std::cin >> result;
	    --result;
	    if (result == -1) {
		std::cout << "! " << seq[md] + 1 << std::endl;
		return 0;
	    }
	    if (md + 1 < n && result == seq[md + 1]) {
		l = md + 1;
	    } else {
		r = md;
	    }
	}
	std::cout << "! " << l + 1 << std::endl;
    }
    return 0;
}

