#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 0
#endif

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

constexpr int MAXC = 1e7 + 1;
vi pr;
int sp[MAXC];

void linear() {
    rep(i, 2, MAXC) {
        if (sp[i] == 0) sp[i] = i, pr.push_back(i);
        for (auto p: pr) {
            if (p > sp[i] || i*p >= MAXC) break;
            sp[i * p] = p;
        }
    }
}

void solve(int test) {
    int a, b;
    cin >> a >> b;

    int ans = -1;

    auto check = [](int a, int b) {
        if (b % a != 0) return false;
        if (a == 1) return true;

        int d = b / a;
        while (d != 1) {
            if (sp[a] < sp[d]) return false;
            d /= sp[d];
        }
        return true;
    };

    for (int d = 1; d * d <= a; d++) {
        if (check(d, a) && check(d, b)) ckmax(ans, d);

        if (check(a / d, a) && check(a / d, b)) ckmax(ans, a / d);
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    linear();

    int T;
    cin >> T;
    rep(test, 1, T + 1) solve(test);
}