#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 0
#endif

#define rep(i, a, b) for (int (i) = a; (i) < (b); ++(i))
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

template<typename T1, typename T2>
bool ckmin(T1& a, const T2& b) {
    return a > b && (a = b, true);
}

template<typename T1, typename T2>
bool ckmax(T1& a, const T2& b) {
    return a < b && (a = b, true);
}

constexpr int MAXC = 1e7 + 1;
vi pr;
int sp[MAXC], mp[MAXC];

void linear() {
    rep(i, 2, MAXC) {
        if (sp[i] == 0) sp[i] = i, pr.push_back(i);
        for (auto p: pr) {
            if (p > sp[i] || i*p >= MAXC) break;
            sp[i * p] = p;
        }
    }

    rep(i, 2, MAXC) {
        if (mp[i] == 0) {
            mp[i] = i;
            for (int j = 2 * i; j < MAXC; j += i) mp[j] = i;
        }
    }
}

void solve(int test) {
    int a, b;
    cin >> a >> b;

    int ans = -1;

    auto check = [](int a, int b) {
        if (b % a != 0) return false;
        if (a == 1) return true;

        int d = b / a;
        return sp[a] >= mp[d];
    };

    int g = gcd(a, b);
    
    for (int d = 1; d * d <= g; d++) {
        if (check(d, a) && check(d, b)) ckmax(ans, d);

        if (check(g / d, a) && check(g / d, b)) ckmax(ans, g / d);
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    linear();

    int T;
    cin >> T;
    rep(test, 1, T + 1) solve(test);
}