#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <random>
#include <bitset>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>

#include <ext/pb_ds/assoc_container.hpp> // РћР±С‰РёР№ С„Р°Р№Р».
#include <ext/pb_ds/tree_policy.hpp> // РЎРѕРґРµСЂР¶РёС‚ РєР»Р°СЃСЃ tree_order_statistics_node_update

using namespace std;
using namespace __gnu_pbds;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,fma,tune=native")

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int int_fast32_t
#define trace(x) cout << #x << " = " << x << endl;
#define trace2(x, y) cout << #x << " = " << x << ' ' << #y << " = " << y << endl;
#define trace3(x, y, z) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << endl;
#define trace4(x, y, z, a) cout << #x << " = " << x << ' ' << #y << " = " << y << ' ' << #z << " = " << z << ' ' << #a << " = " << a << endl;
#define trace_name(x) cout << #x << " = ";
#define trace_all_in(x) cout << #x << " = "; for (auto i : x) cout << i << ' '; cout << endl;

mt19937 rnd(time(0));

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);  // 998244353; //
const ld EPS = (ld)(1e-10);
const ld PI = acos(-1);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(30);
}

template <typename T>
using ordered_set =  tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

struct pt {
    ld x, y;

    pt(){};
    pt(ld x_, ld y_) {
        x = x_;
        y = y_;
    }
};

ld vectornoe(pt a, pt b) {
    return a.x * b.y - a.y * b.x;
}

ld skalyarnoe(pt a, pt b) {
    return a.x * b.x + a.y * b.y;
}

pt diff(pt a, pt b) {
    a.x -= b.x;
    a.y -= b.y;

    return a;
}

ld get_angle(pt a, pt b) {
    return atan2(vectornoe(a, b), skalyarnoe(a, b));
}

vector<pt> a;

bool pt_in_mnog(pt r) {
    int left = 1, right = a.size() - 1;

    while (right - left > 1) {
        int mid = (left + right) / 2;

        if (vectornoe(diff(a[mid], a[0]), diff(r, a[0])) >= 0) left = mid;
        else                                                               right = mid;
    }

    bool flag1 = (vectornoe(diff(a[left], a[0]), diff(r, a[0])) >= -EPS);
    bool flag2 = (vectornoe(diff(a[right], a[left]), diff(r, a[left])) >= -EPS);
//    cout << a[0].x << ' ' << a[0].y << '\n';
//    cout << r.x << ' ' << r.y << '\n';
//    cout << a[right].x << ' ' << a[right].y << '\n';
//    cout << endl;

    bool flag3 = (vectornoe(diff(a[0], a[right]), diff(r, a[right])) >= -EPS);

    return (flag1 && flag2 && flag3);
}

void solve() {
    int n;
    cin >> n;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }

    // reverse(all(a));

    int ind = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i].y < a[ind].y) ind = i;
    }

    vector<pt> b(n);
    for (int i = 0; i < n; ++i) {
        b[i] = a[(ind + i) % n];
    }

    swap(a, b);

    int ans = 0;

    for (int x = 1; x <= 1000; ++x) {
        for (int y = 1; y <= 1000; ++y) {
            if (__gcd(x, y) != 1) continue;

            ans += pt_in_mnog({(ld)x, (ld)y});
        }
    }

    cout << ans;
}

signed main() {
//    freopen("mountain.in", "r", stdin);
//    freopen("mountain.out", "w", stdout);

    fast_stream();

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}

/*

0 1
0 0
1 0
0 -1

*/