#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <stack>
#include <fstream>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 998244353;
long long p = 239, p1 = 911, mod1 = (1e+9) + 7, INF = 1e18;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll binpow(ll a, ll x) {
    if (a == 1 || x == 0) return 1;
    if (x == 1) return a;
    if (x & 1)
        return binpow(a, x - 1) * a % mod1;
    else {
        ll temp = binpow(a, x >> 1);
        return temp * temp % mod1;
    }
}

struct node {
    ll l, r, val, push, ind;
};

struct edge {
    ll x, y1, y2, openfl;
};

const ll N = (1e6) * 2 + 1;
vector<node> tree;

void push(ll v) {
    tree[v].val += tree[v].push;
    if (tree[v].r - tree[v].l != 1) {
        tree[2 * v].push += tree[v].push;
        tree[2 * v + 1].push += tree[v].push;
    }
    tree[v].push = 0;
}

void build(ll v, ll l, ll r) {
    if (r - l == 1) {
        tree[v] = {l, r, 0, 0, l};
        return;
    }
    ll m = l + (r - l) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m, r);
    tree[v] = {l, r, max(tree[2 * v + 1].val, tree[2 * v].val), 0, l};
}

void update(ll v, ll l, ll r, ll val) {
    push(v);
    if (tree[v].r <= l || tree[v].l >= r) return;
    if (tree[v].l >= l && tree[v].r <= r) {
        tree[v].push += val;
        push(v);
        return;
    }
    update(2 * v, l, r, val);
    update(2 * v + 1, l, r, val);
    if (tree[2 * v].val >= tree[2 * v + 1].val) tree[v].ind = tree[2 * v].ind;
    else tree[v].ind = tree[2 * v + 1].ind;
    tree[v].val = max(tree[2 * v].val, tree[2 * v + 1].val);
}

pair<ll, ll> get(ll v, ll l, ll r) {
    push(v);
    if (tree[v].r <= l || tree[v].l >= r) return {-INF, -1};
    if (tree[v].r <= r && tree[v].l >= l) return {tree[v].val, tree[v].ind};
    pair<ll, ll> fr = get(v * 2, l, r), sc = get(2 * v + 1, l, r);
    if (fr.first > sc.first) return fr;
    else return sc;
}

struct cnt{
    ll l = 0, r = 0, next = 0;
};


vector<vector<ll >> g;
ll st = -1, mx = -1;
vector < ll > h, pred;
vector < bool > used;

void dfs(ll v) {
    used[v] = true;
    if (h[v] > mx) {
        mx = h[v];
        st = v;
    }
    for (auto u: g[v]) {
        if (!used[u]) {
            h[u] = h[v] + 1;
            pred[u] = v;
            dfs(u);
        }
    }
}

void solve() {
    ll n, m, q, res = 0;
    cin >> n >> m >> q;
    multiset < pair < ll, ll >> s;
    set < pair < ll, ll >> s1;
    for (ll i = 0 ;i < q;i ++){
        ll x, y;
        cin >> x >> y; x--; y--;
        if (y / m == x / m) {
            s1.insert({x % m, y % m});
            s.insert({x % m, -1});
            s.insert({y % m, 1});
            continue;
        }
        if (x % m != 0) {
            s1.insert({x % m, m - 1});
            s.insert({x % m, -1});
            s.insert({m - 1, 1});
            x = x - x % m + m;
        }
        if (y % m != 0) {
            s1.insert({0, y % m});
            s.insert({0, -1});
            s.insert({y % m, 1});
            y = y - y % m;
        }
        res += max(y - x, 0ll) / m;
    }
    bool fl = true;
    ll now = 0;
    for (auto i: s1) {
        if (i.first > now) {
            fl = false;
            break;
        }
        else now = max(now, i.second);
    }
    if (!fl) {
        cout << res << '\n';
        return;
    }
//    cout << -1 << endl;
    map < ll, ll > mp;
    ll sm = 0;
    ll k = INF, pred = 0;
    for (auto i: s) {
        if (i.first != pred) k = min(k, sm);
        mp[i.first] = max(mp[i.first], sm);
        sm -= i.second;
        mp[i.first] = max(mp[i.first], sm);
        pred = i.first;
    }
    for (auto i: mp) {
        k = min(k, i.second);
    }
    cout << res + k;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}