#include <bits/stdc++.h>
#define int long long
#ifdef LOCAL
#   define debug(x) cout << #x << " = " << (x) << endl
#else
#   define debug(x)
#endif

typedef long long ll;
typedef long double ld;
using namespace std;

const int eps = 1e-5;
struct point {
    ld x = 0, y = 0;
};

ld operator*(point A, point B) {
    return A.x * B.x + A.y * B.y;
}

ld operator%(point A, point B) {
    return A.x * B.y - A.y * B.x;
}

point operator-(point A, point B) {
    return {A.x - B.x, A.y - B.y};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n; cin >> n;
    vector<point> hull(n);
    for (auto& [x, y] : hull) {
        cin >> x >> y;
    }

    auto in = [&hull, &n](point A){
        for (int i = 0; i < n; i++) {
            int j = (i + 1) % n;
            point AB = hull[j] - hull[i];
            point AC = A - hull[i];
            if (AB % AC < -eps) return false;
        }
        return true;
    };

    int cnt = 0;
    for (int i = 1; i <= 1000; i++) {
        for (int j = 1; j <= 1000; j++) {
            if (gcd(i, j) == 1) {
                if (in({(ld)i, (ld)j})) cnt++;
            }
        }
    }
    cout <<cnt;
}