#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

int sign(const ld& a) {
	if (abs(a) < EPS) return 0;
	if (a > 0) return 1;
	return -1;
}

struct Point {
	ld x, y;
	Point() : x(0), y(0) {};
	Point(ld _x, ld _y) : x(_x), y(_y) {};
	Point operator-(const Point& other) const {
		return Point(x - other.x, y - other.y);
	}
	ld operator%(const Point& other) const {
		return x * other.y - y * other.x;
	}
	void input() {
		cin >> x >> y;
	}
};

ll gcd(ll a, ll b) {
	while (b > 0) {
		ll c = b;
		b = a % b;
		a = c;
	}
	return a;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector<Point> p(n);
	for (ll i = 0; i < n; i++) p[i].input();
	ll ans = 0;
	for (ll x = 1; x <= 1000; x++) {
		for (ll y = 1; y <= 1000; y++) {
			if (gcd(x, y) > 1) continue;
			bool b = 1;
			Point v(x, y);
			for (ll i = 0; i < n; i++) {
				ll i1 = (i + 1) % n;
				if (sign((p[i1] - p[i]) % (v - p[i])) < 0) b = 0;
			}
			ans += b;
		}
	}
	cout << ans << "\n";
	return 0;
}