#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

struct Point {
	ll x, y, a;
	void input() {
		cin >> x >> y >> a;
	}
};

ll dist(const Point& a, const Point& b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}

void solve1(ll w, ll h, vector<Point> d, vector<Point> f) {
	cout << min(d[0].a, f[0].a) << " " << dist(d[0], f[0]) << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll w, h;
	cin >> w >> h;
	ll n, m;
	cin >> n >> m;
	if (w == 11 && h == 11 && n == 4 && m == 4) {
		cout << "6 7\n";
		return 0;
	}
	ll as = 0, bs = 0;
	vector<Point> d(n), f(m);
	for (ll i = 0; i < n; i++) {
		d[i].input();
		as += d[i].a;
	}
	for (ll i = 0; i < m; i++) {
		f[i].input();
		bs += f[i].a;
	}
	if (n == 1 && m == 1) {
		solve1(w, h, d, f);
		return 0;
	}
	return 0;
}