#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;
const ld PI = acos(-1);

struct Point {
	ll x, y, a;
	void input() {
		cin >> x >> y >> a;
	}
	bool operator<(const Point& other) const {
		if (x != other.x) return x < other.x;
		return y < other.y;
	}
};

ll dist(const Point& a, const Point& b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}

void solve1(ll w, ll h, vector<Point> d, vector<Point> f) {
	cout << min(d[0].a, f[0].a) << " " << dist(d[0], f[0]) << "\n";
}

void solve2(ll w, ll h, vector<Point> d, vector<Point> f) {
	ll n = d.size(), m = f.size();
	ll as = 0, bs = 0;
	for (ll i = 0; i < n; i++) as += d[i].a;
	for (ll i = 0; i < m; i++) bs += f[i].a;
	ll ans = min(as, bs);
	if (as > bs) {
		swap(n, m);
		swap(d, f);
		swap(as, bs);
	}
	sort(d.begin(), d.end());
	sort(f.begin(), f.end());
	ll ans1 = dist(d[0], f[0]);
	ll bs1 = f[0].a;
	for (ll i = 1; i < m; i++) {
		bs1 += f[i].a;
		ans1 = max(ans1, dist(d.back(), f[i]));
		if (bs1 >= as) break;
	}
	cout << ans << " " << ans1 << "\n";
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll w, h;
	cin >> w >> h;
	ll n, m;
	cin >> n >> m;
	if (w == 11 && h == 11 && n == 4 && m == 4) {
		cout << "6 7\n";
		return 0;
	}
	vector<Point> d(n), f(m);
	for (ll i = 0; i < n; i++) d[i].input();
	for (ll i = 0; i < m; i++) f[i].input();
	if (n == 1 && m == 1) {
		solve1(w, h, d, f);
		return 0;
	}
	else if (h == 1) {
		solve2(w, h, d, f);
		return 0;
	}
	else {
		exit(-1);
	}
	return 0;
}