#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)1e3 + 7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

int solve();

signed main() {
//#ifdef __WIN64__
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);
	int t = 1;
	//cin >> t;
	while (t--) assert(!solve());
}

#define x first
#define y second

pair<int, int> f[N], s[N];
int ok1[N], ok2[N];
pair<int, int> a[N];

int get_sum(int* ar, int szof) {
    int res = 0;
    for (int i = 0; i < szof; ++i) res += ar[i];
    return res;
}

int solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; ++i) cin >> f[i].x >> f[i].y >> s[i].x >> s[i].y;
    for (int i = 0; i < m; ++i) cin >> a[i].x >> a[i].y;

    fill(ok1, ok1 + m, 1);
    fill(ok2, ok2 + m ,1);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (ok1[j] && a[j].x < f[i].y && a[j].y > f[i].x) ok1[j] = 0;
        }
        for (int j = 0; j < m; ++j) {
            if (ok2[j] && a[j].x < s[i].y && a[j].y > s[i].x) ok2[j] = 0;
        }
        if (get_sum(ok1, m) > get_sum(ok2, m)) {
            for (int j = 0; j < m; ++j) ok2[j] = ok1[j];
        } else {
            for (int j = 0; j < m; ++j) ok1[j] = ok2[j];
        }

        //print(ok1, m);
        //print(ok2, m);
    }

    cout << max(get_sum(ok1, m), get_sum(ok2, m)) << "\n";

	return 0;
}
