#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)2e5 + 7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

int solve();

signed main() {
//#ifdef __WIN64__
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);
	int t = 1;
	//cin >> t;
	while (t--) assert(!solve());
}

int mt[N];
int id[N];

vector<int> g[N];

int ask(int c) {
    cout << c << endl;
    int x;
    cin >> x;

    if (x == 0) {
        cout << "! " << c << endl;
        exit(0);
    }
    return x;
}

void dfs(int v, int k = 0, int p = -1) {
    id[v] = k;
    mt[k] = v;
    for (int to : g[v]) {
        if (to != p) {
            dfs(to, k + 1, v);
        }
    }
}

int solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int u = -1;

    for (int v = 0; v < n; ++v) {
        if (g[v].size() == 1) {
            u = v;
            break;
        }
    }

    dfs(u);

    print(mt, n);
    print(id, n);

    int l = 0, r = n + 1;

    while (r - l > 1) {
        int m = (l + r) >> 1;

        int x = ask(mt[m] + 1);
        --x;
        if (id[x] < m) r = m;
        else l = m;
    }

    cout << "! " << mt[l] + 1 << endl;

	return 0;
}
