#define _GLIBCXX_DEBUG

#include "iostream"
#include "vector"
#include "cassert"
#include "cmath"
#include "set"
#include "map"
#include "numeric"
#include "random"
#include "ctime"

#define check(x) cerr << (#x) << " = " << x << "\n"
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple

using namespace std;

using ll = long long;

const int N = (int)1e7;
const int MOD = (int)1e9 + 7;
const int INF = (int)1e9 + 117;
const ll INFll = (ll)1e12 + 117;
const int MAXP = 9999991;

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> inline void print(T* ar, int size_of_ar) {
    for (int i = 0; i < size_of_ar; ++i) cerr << ar[i] << " ";
    cerr << "\n";
}

char prime[N + 1]{};
int d[N + 1];

int solve();

signed main() {
//#ifdef __WIN64__
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	srand(34);

    fill(prime, prime + N + 1, 1);
    prime[0] = prime[1] = 0;

    for (int i = 0; i <= (int)N; ++i) d[i] = i;

    for (int i = 2; (ll)i * i <= N; ++i) {
        if (prime[i]) {
            //d[i] = 1;
            for (int j = i * i; j <= N; j += i) {
                prime[j] = 0;
                while (d[j] % i == 0 && d[j] > i) d[j] /= i;
            }
        }
    }

    //for (int i = 1; i <= 100; ++i) cout << d[i] << "\n";

	int t = 1;
	cin >> t;
	while (t--) assert(!solve());
}

vector<int> fact(int n) {
    vector<int> res;
    for (int d = 2; (ll)d * d <= n; ++d) {
        while (n % d == 0) {
            n /= d;
            res.push_back(d);
        }
    }
    if (n > 1) res.push_back(n);
    return res;
}

int solve() {
    int a, b;
    cin >> a >> b;

    int res = 1;

    while (d[a] == d[b] && a > 1 && b > 1) {
        res *= d[a];
        //check(res);
        a /= d[a];
        b /= d[b];
        //check(a);
        //check(b);
    }

    cout << res << "\n";

	return 0;
}
