#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <random>
#include <bitset>
#include <algorithm>

#define ll long long
#define ld long double
#define int ll

using namespace std;

mt19937 rnd;

struct Seg {
    int l, r, ind, t;

    Seg() = default;
    Seg(int l, int r, int ind, int t) : l(l), r(r), ind(ind), t(t) {}

    bool operator <(Seg a) {
        if (l == a.l) return r < a.r;
        return l < a.l;
    }
};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<Seg>a;
    vector<pair<int, int>>ans1(n);
    for (int i = 0; i < n; ++i) {
        Seg s1, s2;
        cin >> s1.l >> s1.r >> s2.l >> s2.r;
        s1.ind = i;
        s2.ind = i;
        s1.t = 0;
        s2.t = 1;
        a.push_back(s1);
        a.push_back(s2);
    }
    vector<Seg>b;
    for (int i = 0; i < m; ++i) {
        Seg s;
        cin >> s.l >> s.r;
        s.ind = i;
        s.t = 2;
        b.push_back(s);
    }
    int inda = 0;
    int indb = 0;
    for (int i = 0; i < m; ++i) {
        while (inda < a.size() && b[i].l > a[inda].r) ++inda;
        while (inda < a.size() && b[i].r >= a[inda].l) {
            if (a[inda].t == 0) {
                ans1[a[inda].ind].first += max((ll)0, (min(b[i].r, a[inda].r) - max(b[i].l, a[inda].l) + 1));
            }
            else {
                if (a[inda].t == 1) {
                    ans1[a[inda].ind].second += max((ll)0, (min(b[i].r, a[inda].r) - max(b[i].l, a[inda].l) + 1));
                }
            }
            ++inda;
        }
        --inda;
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        ans += b[i].r - b[i].l + 1;
    }
    for (int i = 0; i < n; ++i) {
        ans -= min(ans1[i].first, ans1[i].second);
    }
    cout << ans;
    return 0;
}
