#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <random>
#include <bitset>
#include <algorithm>

#define ll long long
#define ld long double
#define ll int

using namespace std;

mt19937 rnd;

const int N = (1 << 19);
vector<int>a[N];

int sz[N];
pair<int, int> mxsz[N];
bool used[N];

void dfs(int v) {
    used[v] = 1;
    sz[v] = 1;
    for (auto to : a[v]) {
        if (!used[to]) {
            dfs(to);
            if (sz[to] > mxsz[v].first) {
                mxsz[v] = { sz[to], to };
            }
            sz[v] += sz[to];
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        a[x - 1].push_back(y - 1);
        a[y - 1].push_back(x - 1);
    }
    dfs(0);
    vector<int>used1(n);
    int t = 0;
    int cnt = n;
    while (true) {
        if (!used1[t]) {
            used1[t] = 1;
            if (mxsz[t].first * 2 > cnt) t = mxsz[t].second;
            else {
                cout << t + 1 << endl;
                int x;
                cin >> x;
                if (x == 0) {
                    cout << "! " << t + 1 << endl;
                    return 0;
                }
                t = x - 1;
                cnt = sz[t];
            }
        }
        else {
            cout << t + 1 << endl;
            int x;
            cin >> x;
            if (x == 0) {
                cout << "! " << t + 1 << endl;
                return 0;
            }
            t = x - 1;
            cnt = sz[t];
        }
    }
    return 0;
}
