#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};

struct Exam {
    int fl, fr, sl, sr;
};

struct Trip {
    int l, r;
};

bool intersect(int a, int b, int c, int d) {
    return max(a, c) <= min(b, d);
}

struct Event {
    int x, type, index, typeOf;

    Event() {}

    Event(int _x, int _type, int _index, int _typeOf) {
        x = _x, type = _type, index = _index, typeOf = _typeOf;
    }

    bool operator< (const Event &e) const {
        return x == e.x ? type > e.type : x < e.x;
    }
};

void solve(int n, int m) {
    vector<Exam> v;
    vector<Trip> t;

    for (int i = 0; i < n; ++i) {
        int fl, fr, sl, sr; cin >> fl >> fr >> sl >> sr;
        v.push_back(Exam{fl, fr, sl, sr});
    }

    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        if (l != r) return;
        t.push_back(Trip{l, r});
    }

    vector<Event> e;

    for (int i = 0; i < n; ++i) {
        e.push_back(Event{v[i].fl, 1, i, 0});
        e.push_back(Event{v[i].fr, -1, i, 0});
        e.push_back(Event{v[i].sl, 1, i, 1});
        e.push_back(Event{v[i].sr, -1, i, 1});
    }

    for (int i = 0; i < m; ++i) {
        e.push_back(Event{t[i].l, 0, i, 0});
    }

    int balance = 0;
    int ans = 0;
    Event last;
    vector<vector<int>> cnt(2, vector<int>(n, 0));

    for (auto event : e) {
        if (event.type == 0) {
            if (balance == 0) {
                ++ans;
            }
            else {
                ++cnt[last.typeOf ^ 1][last.index];
            }
        }
        else {
            balance += event.type;
            last = event;
        }
    }

    for (int i = 0; i < n; ++i) {
        ans += max(cnt[0][i], cnt[1][i]);
    }

    cout << ans;
}

signed main() {
    fastio;

    int n, m; cin >> n >> m;

    if (m > 10) {
        solve(n, m);
        return 0;
    }

    vector<Exam> v;
    vector<Trip> t;

    for (int i = 0; i < n; ++i) {
        int fl, fr, sl, sr; cin >> fl >> fr >> sl >> sr;
        v.push_back(Exam{fl, fr, sl, sr});
    }

    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        t.push_back(Trip{l, r});
    }

    int ans = 0;

    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<int> index;

        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1)
                index.push_back(i);
        }

        bool bad = false;

        for (int i = 0; i < n; ++i) {
            bool ok = true;

            for (auto ci : index) {
                if (intersect(v[i].fl, v[i].fr, t[ci].l, t[ci].r)) {
                    ok = false;
                    break;
                }
            }

            if (!ok) {
                ok = true;

                for (auto ci : index) {
                    if (intersect(v[i].sl, v[i].sr, t[ci].l, t[ci].r)) {
                        ok = false;
                        break;
                    }
                }

                if (!ok) {
                    bad = true;
                    break;
                }
            }

            if (bad) break;
        }

        if (!bad) ckmax(ans, __builtin_popcount(mask));
    }

    cout << ans;

    return 0;
}