#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;

int n;
vector<vector<int>> g;
vector<int> s;
vector<bool> used;

void sizes(int v, int p = -1) {
    s[v] = 1;

    for (auto to : g[v]) {
        if (to != p && !used[to]) {
            sizes(to, v);
            s[v] += s[to];
        }
    }
}

int centroid(int v, int p = -1, int siz = n) {
    for (auto to : g[v]) {
        if (to != p && !used[to] && s[to] > siz / 2) {
            return centroid(to, v, siz);
        }
    }

    return v;
}

vector<vector<int>> gc;
vector<int> parent;

void rebuild(int v) {
    used[v] = true;
    s.assign(n, 0);
    sizes(v);

    for (auto to : g[v]) {
        if (used[to]) continue;
        int u = centroid(to, v, s[to]);
        parent[u] = v;
        gc[v].push_back(u), gc[u].push_back(v);
        rebuild(u);
    }
}

int l, timer;
vector<int> tin, tout;
vector<vector<int>> up;

void dfs(int v, int p) {
    tin[v] = timer++;
    up[v][0] = p;
    for (int i = 1; i <= l; ++i) up[v][i] = up[up[v][i - 1]][i - 1];

    for (auto to : gc[v]) {
        if (to == p) continue;
        dfs(to, v);
    }

    tout[v] = timer++;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void init() {
    g.resize(n);
    s.resize(n, 0);
    used.resize(n, false);
    gc.resize(n);
    parent.resize(n, -1);
}

void build_lca(int n, int v) {
    while ((1 << l) <= n) ++l;
    tin.resize(n), tout.resize(n), up.resize(n, vector<int>(1 + l));
    dfs(v, v);
}

int ask(int v) {
    cout << v << endl;
    int u; cin >> u;
    return --u;
}

signed main() {
    fastio;

    cin >> n;
    init();

    for (int i = 0; i < n - 1; ++i) {
        int u, v; cin >> u >> v;
        g[--u].push_back(--v), g[v].push_back(u);
    }

    sizes(0);
    used.assign(n, false);
    int start = centroid(0);
    rebuild(start);

    int cur = start;
    build_lca(n, start);

    while (true) {
        int x = ask(cur + 1);

        if (x == -1) {
            cout << "! " << cur + 1 << endl;
            return 0;
        }

        for (int i = l; i >= 0; --i) {
            if (!upper(up[x][i], cur))
                x = up[x][i];
        }

        cur = x;
    }

    return 0;
}