#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};

struct Hash {
    int n, mod, p;
    vector<int> h, deg;

    int add(int a, int b) {
        return a + b >= mod ? a + b - mod : a + b;
    }

    int sub(int a, int b) {
        return a - b < 0 ? a - b + mod : a - b;
    }

    int mul(int a, int b) {
        return 1ll * a * b % mod;
    }

    Hash(const string &s, int _mod, int _p) {
        n = sz(s), mod = _mod, p = _p;
        h.resize(1 + n), deg.resize(1 + n);
        h[0] = 0, deg[0] = 1;

        for (int i = 0; i < n; ++i) {
            h[i + 1] = add(s[i], mul(h[i], p));
            deg[i + 1] = mul(deg[i], p);
        }
    }

    int get(int l, int r) {
        if (l > r) return -1;
        return sub(h[r + 1], mul(h[l], deg[r - l + 1]));
    }
};

signed main() {
    fastio;

    int n, k, a; cin >> n >> k >> a;
    string alph; cin >> alph;
    vector<string> vs(n);
    for (auto &i : vs) cin >> i;

    for (int _ = 0; _ < n; ++_) {
        set<string> ans;

        for (int change = 0; change < k; ++change) {
            char rem = vs[_][change];

            for (auto sym : alph) {
                vs[_][change] = sym;
                Hash h1(vs[_], MODS[0], PS[0]), h2(vs[_], MODS[1], PS[1]);
                bool bad = false;

                for (int i = 0; i < n; ++i) {
                    if (i == _) continue;
                    bool ok = false;
                    Hash hs1(vs[i], MODS[0], PS[0]), hs2(vs[i], MODS[1], PS[1]);

                    for (int diff = 0; diff < k; ++diff) {
                        if (h1.get(0, diff - 1) == hs1.get(0, diff - 1) && h1.get(diff + 1, k - 1) == hs1.get(diff + 1, k - 1)
                        && h2.get(0, diff - 1) == hs2.get(0, diff - 1) && h2.get(diff + 1, k - 1) == hs2.get(diff + 1, k - 1)) {
                            ok = true;
                            break;
                        }
                    }

                    if (ok) {
                        bad = true;
                        break;
                    }
                }

                if (!bad) {
                    ans.insert(vs[_]);
                }
            }

            vs[_][change] = rem;
        }

        cout << sz(ans);
        if (!ans.empty()) cout << " " << *ans.begin();
        cout << "\n";
    }

    return 0;
}