#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define sz(v) (int)v.size()
#define fastio ios_base::sync_with_stdio(false); cin.tie(NULL)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }

    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }

    return false;
}

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const signed N = signed(1e7) + 100, MAXLOG = 20;
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};

string alph;

struct Trie {
    struct Node {
        Node* go[100];
        int cnt = 0;

        Node() {
            for (int i = 0; i < 100; ++i) {
                go[i] = nullptr;
            }
        }
    };

    Node *root;

    Trie() {
        root = new Node();
    }

    void add(const string &s) {
        Node *v = root;

        for (int i = 0; i < sz(s); ++i) {
            int idx = s[i] - 33;
            if (v->go[idx] == nullptr) {
                v->go[idx] = new Node();
            }

            v = v->go[idx];
        }

        ++v->cnt;
    }

    int search(const string &s, Node *v, int pos, bool can) {
        if (pos == sz(s)) {
            return v->cnt;
        }

        int index = s[pos] - 33;

        if (!can) {
            if (v->go[index] == nullptr) return 0;
            return search(s, v->go[index], pos + 1, can);
        }

        int res = 0;

        for (auto sym : alph) {
            if (s[pos] == sym) {
                if (v->go[index])
                    res += search(s, v->go[index], pos + 1, can);
            }
            else {
                if (v->go[sym - 33]) {
                    res += search(s, v->go[sym - 33], pos + 1, !can);
                }
            }
        }

        return res;
    }

    int get(const string &s) {
        int res = 0;

        for (auto i : alph) {
            if (i == s[0]) {
                if (root->go[i - 33])
                    res += search(s, root->go[i - 33], 1, 1);
            }
            else {
                if (root->go[i - 33])
                    res += search(s, root->go[i - 33], 1, 0);
            }
        }

        return res;
    }
};

signed main() {
    fastio;

    int n, k, a; cin >> n >> k >> a;
    cin >> alph;
    vector<string> v(n);

    Trie t;

    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        t.add(s);
        v[i] = s;
    }

    for (int i = 0; i < n; ++i) {
        bool flag = false;
        int cnt = 0;
        string last;

        for (int change = 0; change < k; ++change) {
            char rem = v[i][change];

            for (auto sym : alph) {
                if (sym == rem) {
                    if (flag) continue;
                    flag = true;
                }

                v[i][change] = sym;
                int temp = t.get(v[i]);

                if (t.get(v[i]) == 1) {
                    ++cnt;
                    last = v[i];
                }
            }

            v[i][change] = rem;
        }

        cout << cnt << " " << last << "\n";
    }

    return 0;
}