#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Exam2 {
    int l1, r1, l2, r2;

    Exam2() {}

    Exam2(int l1, int r1, int l2, int r2) : l1(l1), r1(r1), l2(l2), r2(r2) {}
};

struct Exam {
    int l, r;

    Exam() {}

    Exam(int l1, int r1) : l(l1), r(r1) {}

};

void solve() {
    int n, m;
    cin >> n >> m;
    /*
    vector<Exam> a(2 * n + 1);
    for (int i = 1; i <= 2 * n; ++i) {
        cin >> a[i].l >> a[i].r;
    }
    //*/
    //*
    vector<Exam2> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].l1 >> a[i].r1 >> a[i].l2 >> a[i].r2;
    }
    //*/
    vector<vector<pii>> cnt(n + 1, vector<pii> (2, {0, 0}));
    int bonus = 0;
    for (int i = 0, j = 1; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        while (j <= n && a[j].r2 < l && r >= a[j].l1) {
            ++j;
        }
        if (j > n) {
            ++bonus;
            continue;
        }
        if (l <= a[j].l1 && a[j].l2 <= r && r <= a[j].r2) {
            continue;
        }
        if (a[j].l1 <= l && l <= a[j].r1 && a[j].r2 <= r) {
            continue;
        }
        if (l <= a[j].l1 && a[j].r2 <= r) {
            continue;
        }
        if (a[j].l1 <= l && l <= a[j].r1 && a[j].l2 <= r && r <= a[j].r2) {
            continue;
        }
        if (j + 1 <= n && a[j].l2 <= l && l <= a[j].r2 && a[j + 1].l2 <= r) {
            continue;
        }
        if (a[j].r1 < l && r < a[j].l2) {
            ++bonus;
            continue;
        }
        if (j + 1 <= n && a[j].r2 < l && r < a[j + 1].l1) {
            ++bonus;
            continue;
        }
        if (j + 1 <= n && a[j].l2 <= l && l <= a[j].r2 && a[j + 1].l1 <= r && r <= a[j + 1].r1) {
            ++cnt[j][1].second;
            ++cnt[j + 1][0].second;
            continue;
        }

        if ((a[j].l1 <= l && l <= a[j].r1) || (a[j].l1 <= r && r <= a[j].r1) || (l <= a[j].l1 && a[j].r1 <= r)) {
            ++cnt[j][0].first;
            continue;
        }
        if ((a[j].l2 <= l && l <= a[j].r2) || (a[j].l2 <= r && r <= a[j].r2)|| (l <= a[j].l2 && a[j].r2 <= r)) {
            ++cnt[j][1].first;
            continue;
        }
    }
    vector<vector<int>> dp(n + 1, vector<int> (2, 0));
    for (int j = 1; j <= n; ++j) {
        dp[j][0] = cnt[j][1].first + max(dp[j - 1][0], dp[j - 1][1]);
        dp[j][1] = cnt[j][0].first + max(dp[j - 1][0], dp[j - 1][1]);
    }

    for (int j = 1; j <= n; ++j) {
        dp[j][1] = max(dp[j][1], dp[j - 1][0] + cnt[j - 1][1].first + cnt[j][0].first + cnt[j][0].second);
    }

    cout << bonus + max(dp[n][0], dp[n][1]) << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}