#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
#include <chrono>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Hesh {
    int n;
    ll mod, p;
    vector<ll> h;
    vector<ll> pw;

    Hesh(ll _mod, ll _p, string &s) {
        mod = _mod;
        p = _p;
        n = sz(s);
        h.resize(n + 1);
        h[0] = 0;
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 1; i <= n; ++i) {
            h[i] = ((h[i - 1] * p + s[i - 1]) % mod);
            pw[i] = pw[i - 1] * p % mod;
        }
    }

    ll get() {
        return h.back();
    }

};

const ll P = 239;
const ll MOD = 228228227;

void solve() {
    int n, k, len;
    string alph;
    cin >> n >> k >> len >> alph;
    unordered_map<ll, int> cnt;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        string s, t;
        cin >> s;
        a[i] = s;
        Hesh h(MOD, P, s);
        ++cnt[h.get()];
        t = s;
        for (int j = 0; j < k; ++j) {
            for (auto c: alph) {
                if (c == t[j]) {
                    continue;
                }
                t[j] = c;
                h = Hesh(MOD, P, t);
                ++cnt[h.get()];
                t[j] = s[j];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        int ans = 0;
        string sans;
        Hesh h(MOD, P, a[i]);
        if (cnt[h.get()] == 1) {
            ++ans;
            sans = a[i];
        }
        string t = a[i];
        for (int j = 0; j < k; ++j) {
            for (auto c: alph) {
                if (c == t[j]) {
                    continue;
                }
                t[j] = c;
                h = Hesh(MOD, P, t);
                if (cnt[h.get()] == 1) {
                    ++ans;
                    sans = t;
                }
                t[j] = a[i][j];
            }
        }
        cout << ans << ' ' << sans << en;
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
    return 0;
}