#pragma gcc optimize ("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, u, v;
vector<vector<int>> g;
bool blocked[200010];
int maxdi[200010];

inline void dfs1(int x, int p) {
    for (int i : g[x]) {
        if (i != p && !blocked[i]) {
            dfs1(i, x);
            maxdi[x] = max(maxdi[x], maxdi[i] + 1);
        }
    }
}

int mi, mic;

inline void dfscou(int x, int p, int carry) {
    int ma1 = -1, ma2 = -2;
    for (int i : g[x]) {
        if (i == p || blocked[i]) continue;
        if (maxdi[i]+1 > ma1) {
            ma2 = ma1;
            ma1 = maxdi[i] + 1;
        }
        else if (maxdi[i] + 1 > ma2) {
            ma2 = maxdi[i] + 1;
        }
    }
    if (carry > ma1) {
        ma2 = ma1;
        ma1 = carry;
    }
    else if (carry > ma2) {
        ma2 = carry;
    }
    //cout << x << ' ' << ma1 << ' ' << maxdi[x] << endl;
    if (ma1 < mic) {
        mic = ma1;
        mi = x;
    }
    for (int i : g[x]) {
        if (i == p || blocked[i]) continue;
        if (maxdi[i] + 1 == ma1) {
            dfscou(i, x, ma2 + 1);
        }
        else {
            dfscou(i, x, ma1 + 1);
        }
    }
}

inline int getdcentre(int beg) {
    dfs1(beg, -1);
    mic = 1000000000;
    mi = beg;
    dfscou(beg, -1, 0);
    return mi;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> u >> v; --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int pintree = 0, nex;
    while (1) {
        int fi = getdcentre(pintree);
        cout << fi + 1 << endl;
        cin >> nex; --nex;
        if (nex == -1) {
            cout << "! " << fi+1 << endl;
            break;
        }
        blocked[fi] = true;
        pintree = nex;
    }
}
