#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <string>

using namespace std;

typedef long long int ll;
typedef long double ld;

struct SegTreePtr{
    SegTreePtr *l = nullptr, *r = nullptr;
    ll mod = 0, tree = 0;
    ll lb, rb;

    SegTreePtr(ll _lb, ll _rb){
        lb = _lb;
        rb = _rb;
        tree = 0;
        mod = 0;
    }

    void extend(){
        if(l == nullptr){
            ll m = (lb + rb) / 2;
            l = new SegTreePtr(lb, m);
            r = new SegTreePtr(m, rb);
        }
    }

    void push(){
        if(rb - lb == 1){
            mod = 0;
        }
        if(mod == 0){
            return ;
        }
        l->mod += mod;
        r->mod += mod;
        l->tree += mod * (l->rb - l->lb);
        r->tree += mod * (r->rb - r->lb);
        mod = 0;
    }

    void add(ll ql, ll qr, ll val){
        if(rb <= ql || qr <= lb){
            return ;
        }
        extend();
        push();
        if(ql <= lb && rb <= qr){
            tree += val * (rb - lb);
            mod = val;
            return ;
        }
        l->add(ql, qr, val);
        r->add(ql, qr, val);
        tree = min(l->tree, r->tree);
    }

    ll get(ll ql, ll qr){
        if(rb <= ql || qr <= lb){
            return 0;
        }
        extend();
        push();
        if(ql <= lb && rb <= qr){
            return tree;
        }
        return min(l->get(ql, qr), r->get(ql, qr));
    }

};

int main(){
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    ll n, m, q, i, ans, l, r;
    cin >> n >> m >> q;
    SegTreePtr t = SegTreePtr(0, m);
    for(i = 0; i < q; i++){
        cin >> l >> r;
        l -= 1;
        r -= 1;
        if((l / m) != (r / m)){
            //cout << l % m << " " << m << " ---\n";
            t.add(l % m, m, 1);
            t.add(0, (r % m) + 1, 1);
            r -= (r % m);
            l += (m - (l % m));
            t.add(0, m, (r - l) / m);
        }else{
            t.add(l % m, (r % m) + 1, 1);
        }
    }
    ans = t.get(0, m);
    cout << ans;
    return 0;
}
