#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

const int MAX_N = 1e7;
std::vector<int> lp;
std::vector<int> primesss;

void precalc() {
    lp.resize(MAX_N + 1);
    for (int i = 2; i <= MAX_N; ++i) {
        if (lp[i] == 0) {
            lp[i] = i;
            primesss.push_back(i);
        }
        int j = 0;
        while (j < primesss.size() && primesss[j] <= lp[i] && static_cast<long long>(i) * primesss[j] <= MAX_N) {
            lp[i * primesss[j]] = primesss[j];
            ++j;
        }
    }
    return;
}

std::vector<int> fact(int n) {
    /*int pt = 2;
    std::vector<int> ans;
    while (pt * pt <= n) {
        while (n % pt == 0) {
            ans.push_back(pt);
            n /= pt;
        }
        ++pt;
    }
    if (n != 1) {
        ans.push_back(n);
    }
    return ans;*/
    std::vector<int> ans;
    while (lp[n] != n) {
        ans.push_back(lp[n]);
        n = n / lp[n];
        //std::cout << n << std::endl;
    }
    ans.push_back(n);
    return ans;
}

signed main() {

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int n;
    std::cin >> n;
    std::vector<int> a_fact, b_fact;
    precalc();
    for (int i = 0; i < n; ++i) {
        long long a, b;
        std::cin >> a >> b;
        if (a == b) {
            std::cout << a << '\n';
            continue;
        }
        if (a == 1 || b == 1) {
            std::cout << 1 << '\n';
            continue;
        }
        a_fact.clear();
        b_fact.clear();
        a_fact = fact(a);
        b_fact = fact(b);
        //std::vector<int> a_fact = fact(a);
        //std::vector<int> b_fact = fact(b);
        /*for (auto elem : a_fact) {
            std::cout << elem << " ";
        }
        std::cout << std::endl;
        for (auto elem : b_fact) {
            std::cout << elem << " ";
        }
        std::cout << std::endl;*/
        
        int pta = (a_fact.size()) - 1;
        int ptb = (b_fact.size()) - 1;
        while (pta >= 0 && ptb >= 0 && a_fact[pta] == b_fact[ptb]) {
            --pta, --ptb;
        }
        int ans = 1;
        for (int i = ptb + 1; i < b_fact.size(); ++i) {
            ans *= b_fact[i];
        }
        std::cout << ans << '\n';

    }

    return 0;
}