#pragma GCC optimize("O3,unroll-loops,fast-math")
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
const int INF = 1e9 + 7;
const ll LLINF = 2e18 + 13;
mt19937 rng;
uniform_int_distribution<int> uid(0, INF-1);
template<typename T>void smin(T&a,T b) {if(b<a)a=b;}
template<typename T>void smax(T&a,T b) {if(b>a)a=b;}

struct node {
  node *l = nullptr, *r = nullptr;
  ll val;
  ll push = 0;
  node(): val(0) {}
  node(int val): val(val) {}
} *root;

void _push(node *nd, int vl, int vr) {
  if (nd->push) {
    nd->val += nd->push;
    if (vr - vl > 1) {
      if (!nd->l) nd->l = new node();
      if (!nd->r) nd->r = new node();
      nd->l->push += nd->push;
      nd->r->push += nd->push;
    }
    nd->push = 0;
  }
}
const int N = 1 << 30;
ll min(int l, int r, node *nd, int vl, int vr) {
  if (l >= vr || vl >= r) return LLINF;
  _push(nd, vl, vr);
  if (l <= vl && vr <= r) return nd->val;
  int vm = (vl + vr) >> 1;
  ll ans = LLINF;
  if (nd->l)
    ans = min(ans, min(l, r, nd->l, vl, vm));
  if (nd->r)
    ans = min(ans, min(l, r, nd->r, vm, vr));
  return ans;
}
void add(int l, int r, ll val, node *nd, int vl, int vr) {
  _push(nd, vl, vr);
  if (l >= vr || vl >= r) return;
  if (l <= vl && vr <= r) {
    nd->push = val;
    _push(nd, vl, vr);
    return;
  }
  int vm = (vl + vr) >> 1;
  if (!nd->l) nd->l = new node();
  add(l, r, val, nd->l, vl, vm);
  if (!nd->r) nd->r = new node();
  add(l, r, val, nd->r, vm, vr);
  nd->val = min(nd->l->val, nd->r->val);
}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int n, m, q;
  root = new node();
  cin >> n >> m >> q;
  for (int i = 0; i < q; ++i) {
    ll l, r;
    cin >> l >> r;
    --l, --r;
    int lint = l / m;
    int rint = r / m;
    if (lint == rint) {
      add(l % m, r % m + 1, 1, root, 0, N);
    } else {
      add(l % m, m, 1, root, 0, N);
      add(0, m, rint - lint - 1, root, 0, N);
      add(0, r % m + 1, 1, root, 0, N);
    }
  }
  cout << min(0, m, root, 0, N) << endl;

  return 0;
}
